//ROUTINES POUR FICHIERS

 
#include "fichiers/fichiers.h"
#include <fstream>
#include <string>
#include <string.h>

#include <cctype>


//======================================
 // enleve espaces au debut de chaine
string Enleve_espaces_debut(string chaine)
{
  cout<<" Dans fichier.cc Utiliser r.find_last_not_of(whitespaces); plutot"<<endl;
  while(1==1);

  string chaine2;
  int test=0; // 0: debut, 1: milieu, 2: fin de chaine
  for(int i=0;i<chaine.size();i++)
    {
      if((chaine[i]!=' ')&&(test==0)) // debut veritable de la chaine
	test=1;
	
      if(test==1)
	chaine2.push_back(chaine[i]);
    }
  return chaine2;
}
//===========================================
/*
Renvoit les caracteres compris entre chaine1 et chaine2
dans le fichier
(premiere occurence) 
*/
string Extrait_chaine2(string fichier,string chaine1, string chaine2)
{

 ifstream f(fichier.c_str());

 return Extrait_chaine2(f,chaine1,chaine2);
}

//===========================================
/*
Renvoit les caracteres compris entre chaine1 et chaine2
dans le fichier
(premiere occurence  partir du pointeur f) 
rem: chaine1 et chaine2 doivent etre isoles par des espaces
*/
string Extrait_chaine2(ifstream &f,string chaine1, string chaine2)
{

  string result;

  // cout<<"chaine2="<<chaine2<<flush;
      string chaine;
  //----------------
  do
    {
      f>>chaine;
      //cout<<chaine<<flush;
    }
  while ((chaine!=chaine1)&&(!f.eof()));
  //---------------
  if(!f.eof())// chaine 1 trouve 
  {
      f>>chaine;


do
    {
      if(result.empty())
	result=chaine;
      else 
	result+=" "+chaine;
      f>>chaine;
    }
 while ((chaine!=chaine2)&&(!f.eof()));

 if(f.eof()) // chaine 2 pas trouve 
   {result="";
   // cerr<<"chaine1="<<chaine1<<" et chaine2 :"<<chaine2<<" pas trouve"<<endl;
   }
  }//if
//------------------------
 
// cout<<"result="<<result<<endl;
 return result;
}

//===========================================
/*
Renvoit les caracteres (quelconques) compris entre chaine1 et chaine2
dans le fichier
(premiere occurence  partir du pointeur f) 
rem: chaine1 et chaine2 sont quelconques
*/
string Extrait_chaine(ifstream &f,string chaine1, string chaine2)
{

  int res1=prochain2(f,chaine1);

  int pos1=f.tellg();
  int res2=prochain2(f,chaine2);
  int pos2=f.tellg();
  pos2 -=(chaine2.size()+1);
  
  string res;

  //  cout<<"res1*res2="<<res1*res2<<endl;
  if(res1&&res2)
    {
       char caract;
       f.seekg (pos1, ios::beg);
       for(int i=pos1; i<=pos2; i++)
	 {
	   f.get(caract);
	   res=res+caract;
	 }
    }
  //  cout<<"chaine extraite="<<res<<endl;
  
  return res;
}


/*#################################################
petite routine qui va pointer apres le prochain caractere '=' */
int prochain(istream & fich)
{ //unsigned char caract;
char caract;

 do {
	  fich.get(caract);
	  // cout<<caract<<flush;
	 }
 while ((caract!='=')&&(!fich.eof()));

 if (fich.eof()) 
   {
     cerr<<" prochain : fin de fichier trouvee..\n";
     return 0;
   }
 else
   return 1;
}
/*#################################################
petite routine qui va pointer apres la prochaine chaine donnee
 renvoit 0 si pas trouve 1 si trouve  */
int  prochain2(istream & fich, string chaine)
{
 
return   prochain(fich,chaine.c_str());
}

//=============================

string  prochain(istream & fich, string  chaine)
{


  cout<<"Bloqu dans fichier.cc"<<endl;
  while(1==1);
}

//=================================
string  prochain(istream & fich, char c)
{

  char caract;

  string chaine;
  do 
    {
      fich.get(caract);
      // cout<<caract<<flush;
      if((caract!=c)&&(!fich.eof()))
	chaine.push_back(caract);
    }
 while ((caract!=c)&&(!fich.eof()));

 if (fich.eof()) 
   {
     cerr<<" Erreur dans fichier.cc. prochain() : fin de fichier. caractere:"<<c<<" pas trouv..\n";
     while(1==1);
     return 0;
   }
 else
   return chaine;

}

/*#################################################
petite routine qui va pointer apres la prochaine chaine donnee
 renvoit 0 si pas trouve 1 si trouve  */
int  prochain(istream & fich, const char * chaine)

{// unsigned char caract;
  int opt_debug=0; // 1: affiche messages

 

 if(opt_debug) cout<<"Je recherche la chaine="<<chaine<<endl;

 //---------------
char caract;
 int n,i;

 n=strlen(chaine);


//..............
do
 {
 // cherche le premier caractere de la chaine
   do 
     {
	  fich.get(caract);
	  if(opt_debug) cout<<" "<<caract<<flush; // pour debug
	 }
 while ((caract!=chaine[0])&&(!fich.eof()));

 // cout<<"1er Caractere trouv:"<<caract<<endl;
// verifie si il y a le reste de la chaine
   i=0;

  
 if(!fich.eof()&&(n>1))  
   {
     do
       { i++;
	 fich.get(caract);
	 if(opt_debug) 	 cout<<" "<<caract<<flush;
       }
     while((chaine[i]==caract) && (i<(n-1)));
   }
  }// do


//while((i<(n-1))&&(!fich.eof()));
while(!(
        fich.eof()  || (
                         (i==(n-1))  &&   (chaine[n-1]==caract)
                       )
      ));
 
//.......................


 if (fich.eof()) 
   {
     if(opt_debug)      cerr<<" erreur : fin de fichier trouvee..et chaine non trouvee."<<endl;
     return 0;
   }
 else
   { 
     if(opt_debug)      cerr<<" chaine trouvee."<<endl;
     return 1;
   }
}
//*************************************************
/*
int  prochain(ifstream & fich,char * chaine)
{ unsigned char caract;
 int n,i;

n=chaine.length();


do
 {
 // cherche le premier caractere de la chaine
 do {
	  fich.get(caract);
	
	   
	 }
 while ((caract!=chaine[0])&&(!fich.eof()));


// verifie si il y a le reste de la chaine
   i=0;

 if(!fich.eof())  
   {
     do
       { i++;
	 fich.get(caract);
       }
     while((chaine[i]==caract) && (i<(n-1)));
   }
  }
//while((i<(n-1))&&(!fich.eof()));
while(!(
        fich.eof()  || (
                         (i==(n-1))  &&   (chaine[n-1]==caract)
                       )
      ));

 if (fich.eof()) 
   {
     //cerr<<" erreur : fin de fichier trouvee..et chaine non trouvee ..\n";
     return 0;
   }
 else return 1;
}
*/

//=================================================
/* recherche dans le fichier de nom fliste si la chaine  s y trouve  renvoit 1:oui  0:non 
*/

int Present(const char * chaine,const char * fliste)
{
  int res;

ifstream pliste(fliste);
if (pliste) // si  existe 
	res=prochain(pliste,chaine);
else 
    res=0;

return res; 
}

//=================================================
/* rajoute la chaine  a la liste de nom fliste
  s il n y est pas deja 
 retour 1: nouveau (rajoute)   0: deja la
 */

int Rajoute_liste(const char * chaine,const char * fliste)
{
 int res(0);
 //cout<<"Chaine rajoute="<<chaine<<endl;
  if (!Present(chaine,fliste)) 
     {           // la  rajoute a la liste 
      ofstream pliste(fliste,ios::app);

      pliste<<chaine<<endl;
      // cout<<"Chaine rajoute="<<chaine<<endl;
      res=1;
     }
 return res;
}

/*===================================================
Ecrit un nombre dans un fichier 
*/
void Ecrit_fichier(double nbre,const char * nom_fich)
{
 ofstream fich(nom_fich);
  fich<<nbre<<endl;
}
/*===================================================
Lit un nombre dans un fichier 
*/
void Lit_fichier(int & nbre,const char * nom_fich)
{
ifstream fich(nom_fich);
fich>>nbre;
}

/*===================================================
Rajoute  un nombre dans un fichier 
*/
void Rajoute_fichier(double nbre,const char * nom_fich)
{
  ofstream fich(nom_fich,ios::app); //se met en fin de fichier
  fich<<nbre<<endl;
  cout<<"ecriture dans (fichier.cc) "<<nom_fich<<" x="<<nbre<<endl;
}

/*===================================================
Rajoute  un string  dans un fichier 
*/
void Rajoute_fichier(ofstream &f,string chaine)
{
  for(int i=0;i<chaine.size();i++)
    {
      //    cout<<"|"<<char(chaine[i])<<"|"<<endl;
      //cout<<isprint(chaine[i])<<endl; // si caractere imprimable
      if(isprint(chaine[i])||chaine[i]=='\n')
	f<<chaine[i];
    }


}



/*===========================================
Rajoute le fichier2  la suite du fichier 1
opt=1:  la suite, 0: efface
*/
void   Fichier_ajoute(const char * fichier1, const char * fichier2,int opt)
{

  ofstream file1;
  if(opt==1)
    file1.open(fichier1,ios::app);
  else
     file1.open(fichier1);

  ifstream file2(fichier2);

  while(!file2.eof())
    {
      char caract;
      file2.get(caract);
      file1<<caract;
    }

    file1.close();
    file2.close();

}
