//ROUTINES POUR FICHIERS



#if !defined(__FICHIERS_H)
#define __FICHIERS_H

#include "config_fred.h"

#include <stdio.h>
#include <iostream>
#include <fstream>
#include <complex>

//======================================
 // enleve espaces au debut de chaine
string Enleve_espaces_debut(string chaine);

//===========================================
/*
Renvoit les caracteres compris entre chaine1 et chaine2
dans le fichier
(premiere occurence) 
*/
string Extrait_chaine2(string fichier,string chaine1, string chaine2);
//===========================================
/*
Renvoit les caracteres compris entre chaine1 et chaine2
dans le fichier
(premiere occurence  partir du pointeur f) 
*/
string Extrait_chaine2(ifstream &f,string chaine1, string chaine2);


//===========================================
/*
Renvoit les caracteres (quelconques) compris entre chaine1 et chaine2
dans le fichier
(premiere occurence  partir du pointeur f) 
rem: chaine1 et chaine2 sont quelconques
*/
string Extrait_chaine(ifstream &f,string chaine1, string chaine2);
 /*#################################################
petite routine qui va pointer apres le prochain caractere '=' 
renvoit 0: si non trouve et fin de fichier
        1: ok, trouve
*/
int prochain(istream & fich);

/*#################################################
petite routine qui va pointer apres la prochaine chaine donnee
 renvoit 0 si pas trouve 1 si trouve   */
int prochain(istream & fich,const  char * chaine);
//int  prochain(ifstream & fich, char * chaine);
int  prochain2(istream & fich, string chaine);
//idem et renvoit les caracteres intermediaires
string  prochain(istream & fich, string chaine);
string  prochain(istream & fich, char c);


//=================================================
/* recherche dans le fichier de nom fliste si la chaine  s y trouve  renvoit 1:oui  0:non */

int Present(const char * chaine,const char * fliste);


//=================================================
/* rajoute le fichier nom_fichier a la liste de nom fliste
  s il n y est pas deja 
 retour 1: nouveau (rajoute)   0: deja la
 */

int Rajoute_liste(const char * chaine,const char * fliste);

/*===================================================
Ecrit un nombre dans un fichier 
*/
void Ecrit_fichier(double nbre,const char * nom_fich=TEMP"/nbre.txt");
void Lit_fichier(int & nbre,const char * nom_fich=TEMP"/nbre.txt");

/*===================================================
Rajoute  un nombre ou chaine de caractere dans un fichier 
*/
void Rajoute_fichier(double nbre,const char * nom_fich=TEMP"/nbre.txt");


void Rajoute_fichier(ofstream &f,string chaine);



/*===========================================
Rajoute le fichier2  la suite du fichier 1
opt=1:  la suite, 0: efface
*/
void   Fichier_ajoute(const char * fichier1, const char * fichier2,int opt);


#endif








